<?PHP
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * This file is part of Travelsized CMS
 *              A content management system with modules, based on wiki syntax
 *
 * Author: Dan Jensen <admin@leinir.dk>
 * Copyright 2003/2004
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License is available at: http://www.gnu.org/copyleft/
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// Make links for language selection {
	// First, get a list of all the languages
	$fp = opendir("$setup_folder/i18n/");
	while( $file = readdir( $fp ) )
	{
		if( substr( $file, 0, 1 ) != "." )
		{
			// Only include the languages, not the other stuff in the folder
			$languages[] = $file;
			$languages_names[] = trim(file_get_contents("$setup_folder/i18n/$file/name.txt")); // Get the name of the language, in it's own language
		}
	}
	closedir($fp);
	
	// Do the links need any special stuff?
	if ($page_id == 6) { // Edit page
		if ($_REQUEST["edit_frontpage"]) {
			foreach($languages as $key => $value)
				$language_link[$value] = globalIDtoURL("setup/editpage/{$_REQUEST['edit_language']}/0");
		} else if ($_REQUEST["edit_id"]) {
			foreach($languages as $key => $value)
				$language_link[$value] = globalIDtoURL("setup/editpage/{$_REQUEST['edit_language']}/{$_REQUEST['edit_id']}");
		} else {
			foreach($languages as $key => $value)
				$language_link[$value] = globalIDtoURL("setup/editpage/{$_REQUEST['edit_language']}/{$_REQUEST['edit_title']}");
		}
	} else if ($page_id == 8) { // Edit menu menu
		foreach($languages as $key => $value)
			$language_link[$value] = thisPageURL( false, true, array( "page_id" => "8", "menu_id" => $_REQUEST['menu_id'], "language" => $value ) );
	} else { // No special treatment
		if ($page_id == -1) {
			foreach($languages as $key => $value)
				$language_link[$value] = globalIDtoURL("content/$value/$page_title");
		} else {
			foreach($languages as $key => $value)
				$language_link[$value] = globalIDtoURL("content/$value/$page_id");
		}
	}
// Make links for language selection }

?>