<?PHP
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * This file is part of Travelsized CMS
 *              A content management system with modules, based on wiki syntax
 *
 * Author: Dan Jensen <admin@leinir.dk>
 * Copyright 2003/2004
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License is available at: http://www.gnu.org/copyleft/
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

$page_author = $creator_name;
$page_author_email = $creator_email;
$page_menu = 1;
$page_date = formatTime( time() );

if (!auth($_REQUEST["username"], $_REQUEST["password"])) {
	$page_content = loginform($language, globalIDtoURL("setup/editmenu/$menuEditLanguage/$menuEditID"), $auth_messages);
} else if (isauth()) {
	if ($_REQUEST["action"] == "save") {
		$page_title = i18n("Editing menu id ##0##", array($_REQUEST["new_id"]));
		if ($_REQUEST["preview"]) {
			$page_menu = parse_page_data(stripslashes($_REQUEST["new_content"]), $_REQUEST["new_language"], $setup_folder, true);
			$page_content ="
			<p>" . i18n("Look where your menu is normally situated to see, how the newly generated menu will look once saved. Remember the menu is not yet saved!") . "</p><hr />
			<form action=\"" . globalIDtoURL("setup/editmenu/{$_REQUEST['new_language']}/{$_REQUEST['new_id']}") . "\" method=\"POST\">
			<input type=\"hidden\" name=\"action\" value=\"save\" />
			<input type=\"hidden\" name=\"new_id\" value=\"{$_REQUEST["new_id"]}\" />
			<table cellspacing=\"0\" cellpadding=\"2\" class=\"setup\">
			<tr><th colspan=\"2\" class=\"setup-header\">" . i18n("You are editing menu id ##0##", array($_REQUEST["new_id"])) . "
			<tr>
				<td style=\"width: 50%;\" valign=\"top\">
					" . i18n("Title:") . "
				</td><td style=\"width: 50%;\" valign=\"top\">
					<input type=\"text\" value=\"{$_REQUEST["new_title"]}\" style=\"width: 100%;\" name=\"new_title\" />
				</td>
			</tr>
			<tr>
				<td valign=\"top\">
					" . i18n("Languages:") . "
				</td><td valign=\"top\">
					<div align=\"right\"><select style=\"width: 100%;\" name=\"new_language\">";
		
			foreach( $languages as $key => $value )
			{
				if( $_REQUEST["new_language"] == $value )
					$page_content .= "
							<option value=\"$value\" selected=\"true\">{$languages_names[$key]}</option>";
				else
					$page_content .= "
							<option value=\"$value\">{$languages_names[$key]}</option>";
			}
			$page_content .= "
					</select></div>
				</td>
			</tr>";
			if ($theme_options["theme_follows_menu"] == "1") {
				$page_content .= "
			<tr>
				<td valign=\"top\">
					" . i18n("Theme:") . "
				</td><td valign=\"top\">
					<div align=\"right\"><select style=\"width: 100%;\" name=\"new_theme\">
						<option value=\"/none/\">" . i18n("Inherit theme from previously shown page (default behaviour)") . "</option>";
				foreach($theme_folder as $key => $value) {
					$theme_selected = "";
					if ($value == $_REQUEST["new_theme"]) $theme_selected = "selected ";
					$page_content .= "
						<option value=\"$value\" $theme_selected>{$theme_name[$key]}</option>";
				}
				$page_content .= "
					</select></div>
				</td>
			</tr>";
			}
			$page_content .= "
			$formatting_toolbar
			<tr><td colspan=\"2\">
		
			<textarea rows=\"15\" cols=\"70\" style=\"width: 100%;\" id=\"edit\" name=\"new_content\">" . str_replace("&", "&amp;", stripslashes($_REQUEST["new_content"])) . "</textarea>
			</td></tr>
			<tr><td colspan=\"2\">
				<div align=\"center\">
					<input type=\"submit\" name=\"save\" value=\"" . i18n("Save") . "\" />
					<input type=\"submit\" name=\"preview\" value=\"" . i18n("Preview") . "\" />
					<input type=\"reset\" value=\"" . i18n("Reset changes") . "\" />
				</div>
			</td></tr></table></form>
			<p>&nbsp;</p>" . generate_pagehelplink();
		} else {
			if ($pagectl->saveMenuMenu($menu_folder, $_REQUEST["new_id"], $_REQUEST["new_title"], $_REQUEST["new_content"], $_REQUEST["new_language"], $_REQUEST["new_theme"])) {
				if(!array_key_exists("menu_" . $_REQUEST["new_id"] . "_view", $usergroups_default)) {
					setAllowed("menu_" . $_REQUEST["new_id"] . "_view", isAllowed("global_menus_view"));
					setAllowed("menu_" . $_REQUEST["new_id"] . "_edit", isAllowed("global_menus_edit"));
				}
				$page_content = parse_page_data(i18n("The menu was saved."));
				header("Location: " . globalIDtoURL("setup/menusetup") );
			} else {
				$page_content = parse_page_data(i18n("The menu was not saved! Click on your browser's back button and try again."));
			}
		}
	} else {
		$edit_menu["language"] = $menuEditLanguage;
		if ($menuEditID) { //This means edit this menu
			$edit_menu["title"] = $pagectl->fetchMenuTitle($menu_folder, $menuEditID, $menuEditLanguage);
			$edit_menu["menu"] = $pagectl->fetchMenuMenu($menu_folder, $menuEditID, $menuEditLanguage);
			$edit_menu["theme"] = $pagectl->fetchMenuTheme($menu_folder, $menuEditID, $menuEditLanguage);
		} else if ($menuEditTitle) { //This means we wanna make a new menu with this name
			$menuEditID = $pagectl->getFreeMenuID($menu_folder, $pagectl);
			$edit_menu["title"] = $menuEditTitle;
			$edit_menu["language"] = $language;
			$edit_menu["menu"] = i18n("Write your content here. Formatting help can be found below.");
		}
		$edit_menu["title"] = str_replace("&", "&amp;", $edit_menu["title"]);
		$edit_menu["menu"] = str_replace("&", "&amp;", $edit_menu["menu"]);
		$edit_menu["id"] = $menuEditID;
		$page_title = i18n("Editing menu id ##0##", array($edit_menu["id"]));
	
		// Edit menu
		$page_content ="
		<form action=\"" . globalIDtoURL("setup/editmenu/{$edit_menu["language"]}/{$edit_menu["id"]}") . "\" method=\"POST\">
		<input type=\"hidden\" name=\"action\" value=\"save\" />
		<input type=\"hidden\" name=\"new_id\" value=\"{$edit_menu["id"]}\" />
		<table cellspacing=\"0\" cellpadding=\"2\" class=\"setup\">
		<tr><th colspan=\"2\" class=\"setup-header\">" . i18n("You are editing menu id ##0##", array($edit_menu["id"])) . "
		<tr>
			<td style=\"width: 50%;\" valign=\"top\">
				" . i18n("Title:") . "
			</td><td style=\"width: 50%;\" valign=\"top\">
				<input type=\"text\" value=\"{$edit_menu["title"]}\" style=\"width: 100%;\" name=\"new_title\" />
			</td>
		</tr>
		<tr>
			<td valign=\"top\">
				" . i18n("Languages:") . "
			</td><td valign=\"top\">
				<div align=\"right\"><select style=\"width: 100%;\" name=\"new_language\">";
	
		foreach( $languages as $key => $value )
		{
			if( $edit_menu["language"] == $value )
				$page_content .= "
						<option value=\"$value\" selected=\"true\">{$languages_names[$key]}</option>";
			else
				$page_content .= "
						<option value=\"$value\">{$languages_names[$key]}</option>";
		}
		$page_content .= "
				</select></div>
			</td>
		</tr>";
		if ($theme_options["theme_follows_menu"] == "1") {
			$page_content .= "
		<tr>
			<td valign=\"top\">
				" . i18n("Theme:") . "
			</td><td valign=\"top\">
				<div align=\"right\"><select style=\"width: 100%;\" name=\"new_theme\">
					<option value=\"/none/\">" . i18n("Inherit theme from previously shown page (default behaviour)") . "</option>";
			foreach($theme_folder as $key => $value) {
				$theme_selected = "";
				if ($value == $edit_menu["theme"]) $theme_selected = "selected ";
				$page_content .= "
					<option value=\"$value\" $theme_selected>{$theme_name[$key]}</option>";
			}
		$page_content .= "
				</select></div>
			</td>
		</tr>";
		}
		$page_content .= "
		$formatting_toolbar
		<tr><td colspan=\"2\">
	
		<textarea rows=\"15\" cols=\"70\" style=\"width: 100%;\" id=\"edit\" name=\"new_content\">{$edit_menu["menu"]}</textarea>
		</td></tr>
		<tr><td colspan=\"2\">
			<div align=\"center\">
				<input type=\"submit\" name=\"save\" value=\"" . i18n("Save") . "\" />
				<input type=\"submit\" name=\"preview\" value=\"" . i18n("Preview") . "\" />
				<input type=\"reset\" value=\"" . i18n("Reset changes") . "\" />
			</div>
		</td></tr></table></form>
		<p>&nbsp;</p>" . generate_pagehelplink();
	}
}
?>
