<?PHP
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * This file is part of Travelsized CMS
 *              A content management system with modules, based on wiki syntax
 *
 * Author: Dan Jensen <admin@leinir.dk>
 * Copyright 2003/2004
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License is available at: http://www.gnu.org/copyleft/
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

$page_author = $creator_name;
$page_author_email = $creator_email;
$page_menu = 1;
$page_date = formatTime( time() );

if (!auth($_REQUEST["username"], $_REQUEST["password"])) {
	$page_content = loginform($language, globalIDtoURL("setup/pagesetup"), $auth_messages);
} else if (isauth()) {
	$menu_menus = $pagectl->fetchMenuMenuList($menu_folder);
	if ($editFrontpage) {
		if ($_POST["action"] == "save") {
			if ($_POST["preview"]) {
				$page_title = i18n("Previewing front page");
				$page_content = parse_page_data(stripslashes($_POST['new_content'])) . "
				<form action=\"" . globalIDtoURL("setup/editpage/$theEditLanguage/0") . "\" method=\"POST\">
				<input type=\"hidden\" name=\"action\" value=\"save\" />
				<table cellspacing=\"0\" cellpadding=\"2\" class=\"setup\">
				<tr>
					<td style=\"width: 25%;\" valign=\"top\">
						" . i18n("Title:") . "
					</td><td style=\"width: 75%;\" valign=\"top\">
						<input type=\"text\" value=\"" . stripslashes($_POST['new_title']) . "\" style=\"width: 100%;\" name=\"new_title\" />
					</td>
				</tr>
				<tr>
					<td valign=\"top\">
						" . i18n("Languages:") . "
					</td><td valign=\"top\">
						<div align=\"right\"><select style=\"width: 100%;\" name=\"new_language\">";
						foreach($languages as $key => $value) {
							if ($_REQUEST['new_language'] != $value) {
								$page_content .= "
							<option value=\"$value\">{$languages_names[$key]}</option>";
							} else {
								$page_content .= "
							<option value=\"$value\" selected>{$languages_names[$key]}</option>";
							}
						}
			
				$page_content = "$page_content
						</select></div>
					</td>
				</tr>
					<tr>
						<td valign=\"top\">
							" . i18n("Menu:") . "
						</td><td valign=\"top\">
							<div align=\"right\"><select style=\"width: 100%;\" name=\"new_menu\">";
				
					foreach ($menu_menus as $key => $value) {
						if (is_array($value["language"])) {
							if ($value["id"] == $_POST["new_menu"]) {
								$page_content = "$page_content\n					<option value=\"{$value["id"]}\" selected>" . i18n("ID") . " {$value["id"]} (";
							} else {
								$page_content = "$page_content\n					<option value=\"{$value["id"]}\">" . i18n("ID") . " {$value["id"]} (";
							}
							foreach ($value["language"] as $key2 => $value2) {
								$page_content = "$page_content$value2: {$value["title"][$key2]} ";
							}
							$page_content = "$page_content)</option>";
						} else {
							if ($value["id"] == $_POST["new_menu"]) {
								$page_content = "$page_content\n					<option value=\"{$value["id"]}\" selected>" . i18n("ID") . " {$value["id"]} ({$value["language"]}: {$value["title"]})</option>";
							} else {
								$page_content = "$page_content\n					<option value=\"{$value["id"]}\">" . i18n("ID") . " {$value["id"]} ({$value["language"]}: {$value["title"]})</option>";
							}
						}
					}
				
					$page_content = "$page_content
							</select></div>
							<div align=\"right\">" . drawCommand( i18n("Manage"), i18n("Please note that your changes here will be forgotten once you leave to manage the menus"), globalIDtoURL("setup/menusetup") ) . "</div>
						</td>
					</tr>
				$formatting_toolbar
				<tr><td colspan=\"2\">
				<textarea rows=\"15\" cols=\"70\" style=\"width: 100%;\" id=\"edit\" name=\"new_content\">" . stripslashes($_POST['new_content']) . "</textarea>
				</td></tr>
				<tr><td colspan=\"2\">
					<div align=\"center\">
						<input type=\"submit\" name=\"save\" value=\"" . i18n("Save") . "\" />
						<input type=\"submit\" name=\"preview\" value=\"" . i18n("Preview") . "\" />
						<input type=\"reset\" value=\"" . i18n("Reset changes") . "\" />
					</div>
				</td></tr></table></form>
				<p>&nbsp;</p>" . generate_pagehelplink();
			} else {
				$page_title = i18n("Edit front page");
				$datatosave = "<?PHP\n\$page_title = " . var_export(stripslashes($_POST['new_title']), true) . ";\n\$page_content = " . var_export(stripslashes($_POST['new_content']), true) . ";\n\$page_menu=" . $_POST["new_menu"] . "\n?>";
				$page_content = i18n("The page was saved.");
				if (unlink("$setup_folder/i18n/{$_POST['new_language']}/0.inc")) {
					if ($fp = fopen("$setup_folder/i18n/{$_REQUEST['new_language']}/0.inc", 'a')) {
						if (fwrite($fp, $datatosave) === FALSE) {
							$page_content = i18n("The page was not saved! Click on your browser's back button and try again.");
						} else {
							fclose($fp);
							header("Location: " . globalIDtoURL("content/{$_POST['new_language']}/0"));
						}
					} else {
						$page_content = i18n("The page was not saved! Click on your browser's back button and try again.");
					}
				} else {
					$page_content = i18n("The page was not saved! Click on your browser's back button and try again.");
				}
			}
		} else {
			include("$setup_folder/i18n/$theEditLanguage/0.inc");
			$frontpage_title = str_replace("&", "&amp;", $page_title);
			$frontpage_content = str_replace("&", "&amp;", $page_content);
			$page_title = i18n("Edit front page");

			$page_content ="
			<form action=\"" . globalIDtoURL("setup/editpage/$theEditLanguage/0") . "\" method=\"POST\">
			<input type=\"hidden\" name=\"action\" value=\"save\" />
			<table cellspacing=\"0\" cellpadding=\"2\" class=\"setup\">
			<tr>
				<td style=\"width: 25%;\" valign=\"top\">
					" . i18n("Title:") . "
				</td><td style=\"width: 75%;\" valign=\"top\">
					<input type=\"text\" value=\"$frontpage_title\" style=\"width: 100%;\" name=\"new_title\" />
				</td>
			</tr>
			<tr>
				<td valign=\"top\">
					" . i18n("Languages:") . "
				</td><td valign=\"top\">
					<div align=\"right\"><select style=\"width: 100%;\" name=\"new_language\">";
					foreach($languages as $key => $value) {
						if ($theEditLanguage != $value) {
							$page_content .= "
						<option value=\"$value\">{$languages_names[$key]}</option>";
						} else {
							$page_content .= "
						<option value=\"$value\" selected>{$languages_names[$key]}</option>";
						}
					}
		
			$page_content = "$page_content
					</select></div>
				</td>
			</tr>
					<tr>
						<td valign=\"top\">
							" . i18n("Menu:") . "
						</td><td valign=\"top\">
							<div align=\"right\"><select style=\"width: 100%;\" name=\"new_menu\">";
				
					foreach ($menu_menus as $key => $value) {
						if (is_array($value["language"])) {
							if ($value["id"] == $page_menu) {
								$page_content = "$page_content\n					<option value=\"{$value["id"]}\" selected>" . i18n("ID") . " {$value["id"]} (";
							} else {
								$page_content = "$page_content\n					<option value=\"{$value["id"]}\">" . i18n("ID") . " {$value["id"]} (";
							}
							foreach ($value["language"] as $key2 => $value2) {
								$page_content = "$page_content$value2: {$value["title"][$key2]} ";
							}
							$page_content = "$page_content)</option>";
						} else {
							if ($value["id"] == $page_menu) {
								$page_content = "$page_content\n					<option value=\"{$value["id"]}\" selected>" . i18n("ID") . " {$value["id"]} ({$value["language"]}: {$value["title"]})</option>";
							} else {
								$page_content = "$page_content\n					<option value=\"{$value["id"]}\">" . i18n("ID") . " {$value["id"]} ({$value["language"]}: {$value["title"]})</option>";
							}
						}
					}
				
					$page_content = "$page_content
							</select></div>
							<div align=\"right\">" . drawCommand( i18n("Manage"), i18n("Please note that your changes here will be forgotten once you leave to manage the menus"), globalIDtoURL("setup/menusetup") ) . "</div>
						</td>
					</tr>
			$formatting_toolbar
			<tr><td colspan=\"2\">
			<textarea rows=\"15\" cols=\"70\" style=\"width: 100%;\" id=\"edit\" name=\"new_content\">$frontpage_content</textarea>
			</td></tr>
			<tr><td colspan=\"2\">
				<div align=\"center\">
					<input type=\"submit\" name=\"save\" value=\"" . i18n("Save") . "\" />
					<input type=\"submit\" name=\"preview\" value=\"" . i18n("Preview") . "\" />
					<input type=\"reset\" value=\"" . i18n("Reset changes") . "\" />
				</div>
			</td></tr></table></form>
			<p>&nbsp;</p>" . generate_pagehelplink();
		}
	} else {
		if ($_REQUEST["action"] == "save") {
			if ($_REQUEST["preview"]) {
				$page_title = i18n("Preview page id ##0##", array( $_POST["new_id"] ) );
				$page_content = parse_page_data(stripslashes($_POST['new_content'])) . "
					<form action=\"" . globalIDtoURL("setup/editpage/{$_POST['new_language']}/{$_POST['new_id']}") . "\" method=\"POST\">
					<input type=\"hidden\" name=\"new_id\" value=\"{$_POST["new_id"]}\" />
					<input type=\"hidden\" name=\"new_author\" value=\"{$_POST["new_author"]}\" />
					<input type=\"hidden\" name=\"new_author_email\" value=\"{$_POST["new_author_email"]}\" />
					<input type=\"hidden\" name=\"action\" value=\"save\" />
					<table cellspacing=\"0\" cellpadding=\"2\" class=\"setup\">
					<tr><th colspan=\"2\" class=\"setup-header\">" . i18n("You are editing page id: ##0## as ##1##", array($_POST["new_id"], "{$_POST["new_author"]} ({$_POST["new_author_email"]})")) . "
					<tr>
						<td style=\"width: 25%;\" valign=\"top\">
							" . i18n("Title:") . "
						</td><td style=\"width: 75%;\" valign=\"top\">
							<input type=\"text\" value=\"" . stripslashes($_POST["new_title"]) . "\" style=\"width: 100%;\" name=\"new_title\" />
						</td>
					</tr>
					<tr>
						<td valign=\"top\">
							" . i18n("Languages:") . "
						</td><td valign=\"top\">
							<div align=\"right\"><select style=\"width: 100%;\" name=\"new_language\">";
				
					foreach( $languages as $key => $value )
					{
						if( $_POST["new_language"] == $value )
							$page_content .= "
									<option value=\"$value\" selected=\"true\">{$languages_names[$key]}</option>";
						else
							$page_content .= "
									<option value=\"$value\">{$languages_names[$key]}</option>";
					}

				
					$page_content = "$page_content
							</select></div>
						</td>
					</tr>
					<tr>
						<td valign=\"top\">
							" . i18n("Menu:") . "
						</td><td valign=\"top\">
							<div align=\"right\"><select style=\"width: 100%;\" name=\"new_menu\">";
				
					foreach ($menu_menus as $key => $value) {
						if (is_array($value["language"])) {
							if ($value["id"] == $_POST["new_menu"]) {
								$page_content = "$page_content\n					<option value=\"{$value["id"]}\" selected>" . i18n("ID") . " {$value["id"]} (";
							} else {
								$page_content = "$page_content\n					<option value=\"{$value["id"]}\">" . i18n("ID") . " {$value["id"]} (";
							}
							foreach ($value["language"] as $key2 => $value2) {
								$page_content = "$page_content$value2: {$value["title"][$key2]} ";
							}
							$page_content = "$page_content)</option>";
						} else {
							if ($value["id"] == $_POST["new_menu"]) {
								$page_content = "$page_content\n					<option value=\"{$value["id"]}\" selected>" . i18n("ID") . " {$value["id"]} ({$value["language"]}: {$value["title"]})</option>";
							} else {
								$page_content = "$page_content\n					<option value=\"{$value["id"]}\">" . i18n("ID") . " {$value["id"]} ({$value["language"]}: {$value["title"]})</option>";
							}
						}
					}
				
					$page_content = "$page_content
							</select></div>
							<div align=\"right\">" . drawCommand( i18n("Manage"), i18n("Please note that your changes here will be forgotten once you leave to manage the menus"), globalIDtoURL("setup/menusetup") ) . "</div>
						</td>
					</tr>
					$formatting_toolbar
					<tr><td colspan=\"2\">
					<textarea rows=\"15\" cols=\"70\" style=\"width: 100%;\" id=\"edit\" name=\"new_content\">" . stripslashes($_POST["new_content"]) . "</textarea>
					</td></tr>
					<tr><td colspan=\"2\">
						<div align=\"center\">
							<input type=\"submit\" name=\"save\" value=\"" . i18n("Save") . "\" />
							<input type=\"submit\" name=\"preview\" value=\"" . i18n("Preview") . "\" />
							<input type=\"reset\" value=\"" . i18n("Reset changes") . "\" />
						</div>
					</td></tr></table></form>
					<p>&nbsp;</p>" . generate_pagehelplink();
			} else {
				if ($pagectl->savePageData($page_folder, $_POST["new_id"], $_POST["new_language"], $_POST["new_author"], $_POST["new_author_email"], $_POST["new_menu"], $_POST["new_title"], $_POST["new_content"]))
				{
					$page_content = parse_page_data(i18n("The page was saved."));
					update_getpage_id($page_folder, $setup_folder, $pagectl);
					rotate_recent($_POST["new_id"], $_POST["new_title"], $_POST["new_language"], date("j/n/y"), $recent_file);
					header("Location: " . globalIDtoURL("content/{$_POST['new_language']}/{$_POST['new_id']}"));
				}
				else
					$page_content = parse_page_data(i18n("The page was not saved! Click on your browser's back button and try again."));
			}
		} else {
			if ($theEditID)
			{ //This means edit this page
				global $default_language, $language;
				if ($theEditLanguage)
					$edit_page = $pagectl->fetchPageData($theEditID, $theEditLanguage);
				else
					$edit_page = $pagectl->fetchPageData($theEditID, $default_language);
			}
			else if ($theEditTitle)
			{ //This means we wanna make a new page with this name
				$edit_page["id"] = $pagectl->getFreePageID($page_folder, $pagectl);
				$edit_page["title"] = $theEditTitle;
				$edit_page["language"] = $language;
				$edit_page["content"] = i18n("Write your content here. Formatting help can be found below.");
			}
			$edit_page["title"] = str_replace("&", "&amp;", $edit_page["title"]);
			$edit_page["content"] = str_replace("&", "&amp;", $edit_page["content"]);
			$edit_page["author"] = getUserInfo(currentUser(), "name");
			$edit_page["email"] = getUserInfo(currentUser(), "email");
			$page_title = i18n("Edit page id ##0##", array( $edit_page["id"] ) );
			$page_content ="
			<form action=\"" . globalIDtoURL("setup/editpage/{$edit_page['language']}/{$edit_page['id']}") . "\" method=\"POST\">
			<input type=\"hidden\" name=\"new_id\" value=\"{$edit_page["id"]}\" />
			<input type=\"hidden\" name=\"new_author\" value=\"{$edit_page["author"]}\" />
			<input type=\"hidden\" name=\"new_author_email\" value=\"{$edit_page["email"]}\" />
			<input type=\"hidden\" name=\"action\" value=\"save\" />
			<table cellspacing=\"0\" cellpadding=\"2\" class=\"setup\">
			<tr><th colspan=\"2\" class=\"setup-header\">" . i18n("You are editing page id: ##0## as ##1##", array($edit_page["id"], "{$edit_page["author"]} ({$edit_page["email"]})")) . "
			<tr>
				<td style=\"width: 25%;\" valign=\"top\">
					" . i18n("Title:") . "
				</td><td style=\"width: 75%;\" valign=\"top\">
					<input type=\"text\" value=\"{$edit_page["title"]}\" style=\"width: 100%;\" name=\"new_title\" />
				</td>
			</tr>
			<tr>
				<td valign=\"top\">
					" . i18n("Languages:") . "
				</td><td valign=\"top\">
					<div align=\"right\"><select style=\"width: 100%;\" name=\"new_language\">";
		
			foreach( $languages as $key => $value )
			{
				if( $edit_page["language"] == $value )
					$page_content .= "
						<option value=\"$value\" selected=\"true\">{$languages_names[$key]}</option>";
				else
					$page_content .= "
						<option value=\"$value\">{$languages_names[$key]}</option>";
			}

		
			$page_content = "$page_content
					</select></div>
				</td>
			</tr>
			<tr>
				<td valign=\"top\">
					" . i18n("Menu:") . "
				</td><td valign=\"top\">
					<div align=\"right\"><select style=\"width: 100%;\" name=\"new_menu\">";
		
			foreach ($menu_menus as $key => $value) {
				if (is_array($value["language"])) {
					if ($value["id"] == $edit_page["menu"]) {
						$page_content = "$page_content\n					<option value=\"{$value["id"]}\" selected>" . i18n("ID") . " {$value["id"]} (";
					} else {
						$page_content = "$page_content\n					<option value=\"{$value["id"]}\">" . i18n("ID") . " {$value["id"]} (";
					}
					foreach ($value["language"] as $key2 => $value2) {
						$page_content = "$page_content$value2: {$value["title"][$key2]} ";
					}
					$page_content = "$page_content)</option>";
				} else {
					if ($value["id"] == $edit_page["menu"]) {
						$page_content = "$page_content\n					<option value=\"{$value["id"]}\" selected>" . i18n("ID") . " {$value["id"]} ({$value["language"]}: {$value["title"]})</option>";
					} else {
						$page_content = "$page_content\n					<option value=\"{$value["id"]}\">" . i18n("ID") . " {$value["id"]} ({$value["language"]}: {$value["title"]})</option>";
					}
				}
			}
		
			$page_content = "$page_content
					</select></div>
							<div align=\"right\">" . drawCommand( i18n("Manage"), i18n("Please note that your changes here will be forgotten once you leave to manage the menus"), globalIDtoURL("setup/menusetup") ) . "</div>
				</td>
			</tr>
			$formatting_toolbar
			<tr><td colspan=\"2\">
			<textarea rows=\"15\" cols=\"70\" style=\"width: 100%;\" id=\"edit\" name=\"new_content\">{$edit_page["content"]}</textarea>
			</td></tr>
			<tr><td colspan=\"2\">
				<div align=\"center\">
					<input type=\"submit\" name=\"save\" value=\"" . i18n("Save") . "\" />
					<input type=\"submit\" name=\"preview\" value=\"" . i18n("Preview") . "\" />
					<input type=\"reset\" value=\"" . i18n("Reset changes") . "\" />
				</div>
			</td></tr></table></form>
			<p>&nbsp;</p>" . generate_pagehelplink();
		}
	}
}
?>
