<?php
/**
* BloggerMod2 for Travelsized CMS
* @author	Dan Jensen <admin@leinir.dk>
* @date		2007-12-10
* @version	0.1
*/


// Register module human name, version and description.
$modules_names[] = "BloggerMod2";
$mopules_versions[] = "0.1";
$modules_descriptions[] = "Category based blogging module - one blog per user, with both global and personal categories";

// Register the module into module settings
$modules_setup[] = "modulesetup_blogger";

// Register the module into profile modules
$profilemodules[] = "profilemodule_blogger";

// Register the module into globalID
$modules_globalID[] = "globalID_blogger";

// Register the module's parsing function
$modules[] = "parse_blogger";

// Give help to using the whole blogging module system
$page_help["--- in blog entry"] = "This will cause BloggerMod to cut the entry here when not showing the full entry - it will still be parsed as a horizontal line normally";
$page_help["&#92;blogall(txt1, txt2, txt3)"] = "Will show you a list of blog entries by all users in the system, optionally with the space-delimited category list txt1. If txt2 is present, it is the amount of blog items to show. If txt3 is present, it is the number of items that will be rendered tiny (that is, with only the header)";
$page_help["&#92;blog(txt1, txt2, txt3, txt4)"] = "Will show you a list of blog entries by the user txt1, optionally limited to the categories defined by the space-delimited list txt2. If txt3 is present, it is the amount of blog items to show. If txt4 is present, it is the number of items that will be rendered tiny (that is, with only the header)";


include( "$module_folder/blogger/code/blogger_entryEditor.php" );
include( "$module_folder/blogger/code/blogger_entry.php" );
include( "$module_folder/blogger/code/blogger_userOptions.php" );
include( "$module_folder/blogger/code/blogger_user.php" );
include( "$module_folder/blogger/code/blogger_entries.php" );

/**
 * Looks for \\blog() \\blogall() and \\blogfeed()
 *
 */
function parse_blogger( $page_data )
{
	global $globalID, $page_id, $page_title, $meta_headers, $module_folder;
	
	$loopcontrol = 0;
	$moduleCommandName = "blogfeedall";
	while( $parameters = spotModuleCommand( $page_data, $moduleCommandName, &$loopcontrol ) )
	{
		if( $parameters == " " )
			$parameters = "";
		
		list( $users, $categories ) = split( ",", $parameters );
		
		$users = split( " ", trim($users) );
		$categories = split( " ", trim($categories) );
		
		$showThis = new blogger_entries( $users, $categories );
		
		$replaceData = $showThis->renderFeed();
		$rendered = true;
		
		$page_data = str_replace( "\\$moduleCommandName($parameters)", $replaceData, $page_data );
	}
	
	$loopcontrol = 0;
	$moduleCommandName = "blogfeed";
	
	while( $parameters = spotModuleCommand( $page_data, $moduleCommandName, &$loopcontrol ) )
	{
		if( $parameters == " " )
			$parameters = "";
		
		if( strpos( $parameters, "," ) > 0 )
			list( $users, $categories ) = split( ",", $parameters );
		else
			list( $users, $categories ) = array( null, $parameters );
		
		$categories = split( " ", trim($categories) );
		
		$showThis = new blogger_entries( null, $categories );
		
		$replaceData = $showThis->renderFeed();
		$rendered = true;
		
		$page_data = str_replace( "\\$moduleCommandName($parameters)", $replaceData, $page_data );
	}
	
	$loopcontrol = 0;
	$moduleCommandName = "blogall";
	while( $parameters = spotModuleCommand( $page_data, $moduleCommandName, &$loopcontrol ) )
	{
		if( $parameters == " " )
			$parameters = "";
		
		list( $categories, $limit, $limitTiny ) = split( ",", $parameters );
		
		$categories = split( " ", trim($categories) );
		
		$showThis = new blogger_entries( null, $categories );
		
		if( is_numeric($limit) && $limit > 0 )
			$showThis->limit = $limit;
		if( is_numeric($limitTiny) && $limitTiny > 0 )
			$showThis->limitTiny = $limitTiny;
		
		$replaceData = $showThis->render();
		$meta_headers .= "
<link rel=\"alternate\" type=\"application/rss+xml\" title=\"$page_title RSS\" href=\"" . siteURL() . "?module_function=blogfeed(" . implode( " ", $categories ) . ")\" />";
		$rendered = true;
		
		$page_data = str_replace( "\\$moduleCommandName($parameters)", $replaceData, $page_data );
	}
	
	$loopcontrol = 0;
	$moduleCommandName = "blog";
	while( $parameters = spotModuleCommand( $page_data, $moduleCommandName, &$loopcontrol ) )
	{
		if( $parameters == " " )
			$parameters = "";
		
		list( $users, $categories, $limit, $limitTiny ) = split( ",", $parameters );
		
		$users = split( " ", trim($users) );
		$categories = split( " ", trim($categories) );
		
		$showThis = new blogger_entries( $users, $categories );
		
		if( is_numeric($limit) && $limit > 0 )
			$showThis->limit = $limit;
		if( is_numeric($limitTiny) && $limitTiny > 0 )
			$showThis->limitTiny = $limitTiny;
		
		$replaceData = $showThis->render();
		$meta_headers .= "
<link rel=\"alternate\" type=\"application/rss+xml\" title=\"$page_title RSS\" href=\"" . siteURL() . "?module_function=blogfeed(" . implode( " ", $users ) . "," . implode( " ", $categories ) . ")\" />";
		$rendered = true;
		
		$page_data = str_replace( "\\$moduleCommandName($parameters)", $replaceData, $page_data );
	}
	
	if( $rendered )
		$meta_headers .= "
	<link rel=\"StyleSheet\" href=\"" . siteURL(true) . "$module_folder/blogger/blogger.css\" type=\"text/css\" />";
	
	return $page_data;
}

function profilemodule_blogger()
{
	global $tabwidget, $meta_headers, $module_folder, $viewUser, $globalID, $permissionlevels_array, $setup_folder;
	
	$meta_headers .= "\n<link rel=\"StyleSheet\" href=\"" . siteURL(true) . "$module_folder/blogger/blogger.css\" type=\"text/css\" />";
	
	$splitID = split( "/", $globalID );
	
	// If we have a number, it means we want to show an entry
	if( array_key_exists( 3, $splitID ) && is_numeric( $splitID[3] ) )
	{
		// Get all entries for the user $splitID[1]
		$entries = new blogger_entries( array( $viewUser ) );
		$renderedData = $entries->render( $viewUser, $splitID[3] );
	}
	// Otherwise, show it all
	else
	{
		// If we actually do have a fourth entry anyway, it means we're either editing, or showing a category/categories
		if( array_key_exists( 3, $splitID ) )
		{
			// Either we're editing the user's entries...
			if( profileEditAllowed($viewUser) && ( $splitID[3] == "edit" || $splitID[3] == "delete" || $splitID[3] == "publish" ) )
			{
				// Get all entries for the user $splitID[1]
				$entries = new blogger_entries( array( $viewUser ) );
				$entries->edit = true;
				$renderedData = $entries->render( $viewUser );
			}
			// We are showing an entry
			else if( $splitID[3] == "entry" )
			{
				if( array_key_exists( 4, $splitID ) && is_numeric( $splitID[4] ) )
				{
					// Get all entries for the user $splitID[1]
					$entries = new blogger_entries( array( $viewUser ) );
					$renderedData = $entries->render( $viewUser, $splitID[4] );
				}
				else
					header("Location: " . globalIDtoURL( "user/" . $viewUser . "/blogger") );
			}
			// Or we're showing categories...
			else
			{
				// Get all entries for the user $splitID[1] with the category $splitID[3]
				$entries = new blogger_entries( array( $viewUser ), split( " ", $splitID[3] ) );
				$renderedData = $entries->render( $viewUser );
			}
		}
		else
		{
			// Get all entries for the user $splitID[1]
			$entries = new blogger_entries( array( $viewUser ) );
			$renderedData = $entries->render();
		}
	}
	
	if( profileEditAllowed($viewUser) )
	{
		$imageOn = siteURL(true) . "$setup_folder/images/selection-on.png";
		$imageOff = siteURL(true) . "$setup_folder/images/selection-off.png";
		
		$images["categories"] = $images["external"] = $images["options"] = $images["edit"] = $images["view"] = $imageOff;
		
		if( $splitID[5] == "categories" )
			$images["categories"] = $imageOn;
		else if( $splitID[5] == "external" )
			$images["external"] = $imageOn;
		else if( $splitID[4] == "options" )
			$images["options"] = $imageOn;
		else if( $splitID[3] == "edit" || $splitID[3] == "delete" )
			$images["edit"] = $imageOn;
		else
			$images["view"] = $imageOn;
		
		$tabwidget->addCommand( i18n("New entry"), i18n("Create a new blog entry"), globalIDtoURL("user/$viewUser/blogger/edit/entry/new") );
		$tabwidget->addCommandSeparator();
		$tabwidget->addCommand( i18n("Categories"), i18n("Manage the personal categories"), globalIDtoURL("user/$viewUser/blogger/edit/options/categories"), $images["categories"] );
		$tabwidget->addCommand( i18n("External Feeds"), i18n("Manage the agregated data"), globalIDtoURL("user/$viewUser/blogger/edit/options/external"), $images["external"] );
		$tabwidget->addCommand( i18n("Options"), i18n("Manage the options for the blogging module"), globalIDtoURL("user/$viewUser/blogger/edit/options"), $images["options"] );
		$tabwidget->addCommandSeparator();
		$tabwidget->addCommand( i18n("View"), i18n("View the blog entries"), globalIDtoURL("user/$viewUser/blogger"), $images["view"] );
		$tabwidget->addCommand( i18n("Edit"), i18n("Edit the blog and its entries"), globalIDtoURL("user/$viewUser/blogger/edit"), $images["edit"] );
	}
	
	return $renderedData;
}

/**
 * Returns the url that corresponds to the globalID corresponding to a blog item if appropriate
 *
 * @param     $splitID       The global ID to check
 *
 * @return    string         A string containing the URL corresponding to the globalID, if existing
 */
function globalID_blogger( $splitID )
{
	$pageID = null;
/*	
	// Is the globalID directly aimed at this module?
	// Not yet implemented - blogger mod does not know which page the blog is on...
	if( $splitID[0] == "blogger" )
	{
		$_REQUEST["page_id"] = $foo_pageID;
		$pageID = $foo_pageID;
	}
	else
	*/
	// Or is it aimed at the module's profile module?
	if( $splitID[0] == "user" && $splitID[2] == "blogger" )
	{
		$_REQUEST["module"] = "profilemodule_blogger";
		$pageID = "13";
	}
	
	return $pageID;
}

function blogger_savecategories()
{
	global $setup_folder, $blogcategories;
	
	$filename = "$setup_folder/modules/blogger/categories.php";
	if (file_exists($filename))
		unlink($filename);
	
	natcasesort($blogcategories); // Sort categories alphabetically...
	
	file_put_contents($filename, array_export( $blogcategories, "blogcategories" ) );
	
	chmod($filename, 0664);// make sure the file is actually accessible...
}

$filename = "$setup_folder/modules/blogger/categories.php";
if (file_exists($filename))
	include($filename);
else
{
	$blogcategories = array("system_category");
	blogger_savecategories();
}

function modulesetup_blogger()
{
	global $blogcategories, $theModuleSection, $theModuleSubsection;
	
	/// Make sure that system_category is always available and always the first item...
	/// Do this by snipping it out before handing it to the editor, and adding it back in after editing
	$dialog = new SimpleListEditor( "setup/modulesetup/blogger", $theModuleSection, $blogcategories, $theModuleSubsection );
	$dialog->title = i18n("Category");
	$dialog->description = i18n("A string containing the name of the category. Please note that any spaces will be translated to underscores.");
	$renderedContent = renderInformationBox( i18n("Categories"), $dialog->render() );
	if( $dialog->changed )
	{
		foreach( $dialog->items as $key => $value )
			$dialog->items[$key] = str_replace( " ", "_", $value );
		// Insert the system category item and then add all the rest of the items
		$blogcategories = array( "system_category" ) + $dialog->items;
		blogger_savecategories();
	}
	
	// We show help at the bottom of the page on the overview, not the edit subsections...
	if( $theModuleSection == "" )
		$renderedContent .= renderInformationBox( i18n("System entries"), i18n("To create system entries, add the System category to your entries. Only administrators are able to use the System category. Use &#92;blogall(system_category) to show these entries.") );
	
	return $renderedContent;
}

/**
 * Return an array of data about the thumbnail for a global ID
 * As the blog entries don't have thumbnails per se, we simply pass a fitting image directly back
 *
 * @param     splitID        The global ID to check
 *
 * @return    Array containing array
 */
function globalIDThumbnail_blogger( $splitID )
{
	global $module_folder;
	$data = array( "uri" => siteURL(true) . "$module_folder/blogger/thumb.png", "width" => 64, "height" => 64 );
	return $data;
}

?>
