<?PHP
/**
 * RSS Reader module for Travelsized CMS
 *
 * @Author	Dan Jensen <admin@leinir.dk>
 */

$modules_names[] = "RSS Reader";
$mopules_versions[] = "0.3";
$modules_descriptions[] = "Reads properly formatted RSS files (no setup required)";

$modules_setup[] = "modulesetup_lastrss";

$modules[] = "parse_lastrss";

$page_help["&#92;readrss(txt1)"] = "This will show the items in the rss feed defined by txt1";

// Usergroup defaults {
$usergroups_global_default["modules_lastrss_view"] = true;
// Usergroup defaults }

require_once "$module_folder/lastrss/lastRSS.php";

function parse_lastrss($page_data) {
	// Create lastRSS object
	$rss = new lastRSS;

	// Set cache dir and cache time limit (1200 seconds)
	// (don't forget to chmod cahce dir to 777 to allow writing)
	$rss->cache_dir = './lastrss/temp';
	$rss->cache_time = 1200;

	while (true) {
		$begpos = strpos($page_data, "\\readrss("); //where does the first feed begin
		if ($begpos === false) break; //all feeds have been parsed, no need to check more
		$endpos = strpos($page_data, ")", $begpos + 8); //feed end

		$url = substr( $page_data, $begpos + 9, ($endpos - $begpos) - 9);
		$rssfeed = "";

		// Try to load and parse RSS file
		if ($rs = $rss->get($url)) {
			// Show website logo (if presented)
			if ($rs[image_url] != '') {
				$rssfeed .= "<a href=\"$rs[image_link]\"><img src=\"$rs[image_url]\" alt=\"$rs[image_title]\" border=\"0\" /></a><br />\n";
			}
			
			// Show clickable website title
			// $rssfeed .= "<big><b><a href=\"$rs[link]\">$rs[title]</a></b></big><br />\n";
			// Show website description
			// $rssfeed .= "$rs[description]<br />\n";
			
			// Show last published articles (title, link, description)
			$rssfeed .= "<ul class=\"wikilist\">\n";
			if (is_array($rs['items'])) {
				foreach($rs['items'] as $item) {
					$rssfeed .= "\t<li class=\"wikilist\"><a href=\"$item[link]\">".$item['title']."</a><br />".$item['description']."</li>\n";
				}
			} else {
				$rssfeed .= "\t<li class=\"wikilist\"><p class=\"comment\">No news items...</p></li>\n";
			}
			$rssfeed .= "</ul>\n";
		} else {
			$rssfeed .= "Error: It's not possible to reach RSS file...\n";
		}
		$rssfeed .= "<div class=\"comment\" style=\"font-size: 9px; text-align: right;\">RSS Reader by<br /><a class=\"comment\" href=\"http://lastrss.oslab.net/\" target=\"_blank\">lastRSS</a></div>\n";
		$page_data = str_replace("\\readrss($url)", $rssfeed, $page_data);
	}
	return $page_data;
}

function modulesetup_lastrss() {
	return "<div>The RSS Reader module does not need setting up. To use, type the following into your page, replacing url with the url to your RSS feed:</div><hr /><div>\\readrss(url)</div>";
}

?>