<?PHP
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * This file is part of Travelsized CMS
 *              A content management system with modules, based on wiki syntax
 *
 * Author: Dan Jensen <admin@leinir.dk>
 * Copyright 2003/2004
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License is available at: http://www.gnu.org/copyleft/
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// Functions used for URL creation in the system
include "shared-urls.php";

// Functions used to handle strings
include "shared-strings.php";

// Functions used to handle arrays
include "shared-arrays.php";

// Functions used to handle files and directories
include "shared-filefunctions.php";

// Functions for handling images
include "shared-graphics.php";

// Convenience functions for creating pretty things (for example information boxes)
include "shared-pretties.php";

// Error handling
include "shared-errorhandler.php";

// Functions for handling things used in profiles, such as the avatar images, and also loads profile options
include "shared-profile.php";

// Functions and classes used in site setup, especially the setupPage, optionsRow and optionsPanel classes
include "shared-setup.php";

// The lockable class, which enables locking a class for access
include "shared-lockableclass.php";

// The tabbar class
include "tabbar.class.php";

// The table model handler/renderer class
include "shared-tablehandler.php";

// The simple list editor, which lets you add, delete and edit items from an array of simple text items
include "shared-simplelisteditor.php";

// A tool for creating feeds (rss, atom...)
include "feed-creator.php";

// A tool for handling broad folksonomies (that is, associations between usernames, globalIDs and keywords)
include "shared-tags.php";

?>