<?PHP
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * This file is part of Travelsized CMS
 *              A content management system with modules, based on wiki syntax
 *
 * Author: Dan Jensen <admin@leinir.dk>
 * Copyright 2003/2004
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License is available at: http://www.gnu.org/copyleft/
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

include ("tagwall.class.php");
$tagwall = new Tagwall();
$tagwall->setFile("$setup_folder/tagwall.txt");

$page_author = $creator_name;
$page_author_email = $creator_email;
$page_menu = 0;
$page_date = formatTime( time() );
$page_title = i18n("Tag wall");

if ($add_tag) {
	// Set cookie to last for an hour
	setcookie ("ubergheytagwall", "1", time()+3600);
	//Check for cookie
	if (isset($_COOKIES["ubergheytagwall"])) {
		$page_content = "<div style=\"color: red\">" . i18n("You can only submit once an hour!") . "</div>";
	} else {
		$tagwall->insertTagwallData($_REQUEST["name"], $_REQUEST["email"], htmlspecialchars($_REQUEST["text"]));
		$page_content = "<div>" . i18n("Thank you for your comment.") . "</div>";
	}
} else {
	$temp_tagwall_data = $tagwall->fetchTagwallData();
	//Build the tag wall from this data and put it into $tagwall_data
	$tagwall_data = "<div align=\"center\">";
	if (is_array($temp_tagwall_data)) {
		foreach ($temp_tagwall_data as $tag_key => $key_name) {
			$tag_text = parse_page_data($temp_tagwall_data[$tag_key]["text"], $language);
			$tagwall_data = "$tagwall_data
		<table width=\"90%\" style=\"border: 0;\">
		<tr><td width=\"70%\" style=\"border: 1px solid gray;\">
		<div>{$temp_tagwall_data[$tag_key]['name']} (<a href=\"mailto:{$temp_tagwall_data[$tag_key]['email']}\">{$temp_tagwall_data[$tag_key]['email']}</a>)</div></td>
		<td width=\"30%\" style=\"border: 1px solid gray;\"><div align=\"right\">{$temp_tagwall_data[$tag_key]['date']}</div></td>
		<tr><td style=\"border: 1px solid gray;\" colspan=\"2\">$tag_text</td></tr>
		</td></tr></table>
		<br />";
		}
	} else {
		$tagwall_data = "$tagwall_data
		<table width=\"90%\" style=\"border: 0;\">
		<tr><td><div class=\"comment\">0 tags</div></td></tr>
		</table>
		<br />";
	}
	$tagwall_data = "$tagwall_data</div>";
	$page_content = "
	$tagwall_data
	<br />
	<form action=\"" . thisPageURL( false, true, array( "add_tag" => "1" ) ) . "\" method=\"post\">
	<div align=\"center\"><table width=\"460\" style=\"border: 1px solid gray;\">
	<tr><td><div>" . i18n("Name:") . "</div>
	</td><td><div align=\"right\"><input type=\"text\" name=\"name\"></div>
	<tr><td><div>" . i18n("Email:") . "</div>
	</td><td><div align=\"right\"><input type=\"text\" name=\"email\"></div>
	<tr><td><div>" . i18n("Your tag:") . "</div>
	</td><td><div align=\"right\"><textarea name=\"text\" rows=4 cols=40></textarea></div>
	</td></tr>
	<tr><td colspan=\"2\"><div align=\"center\"><input type=\"submit\" value=\"" . i18n("Add your tag") . "\"></div></td></tr>
	<tr><td style=\"border-top: 1px solid gray\" colspan=\"2\">
	<div>{$commands["help"]}</div>
	" . generate_pagehelplink() . "
	</td></tr>
	</table></div>
	</form>
	";
}
?>
